#pragma once

#include "accessing.h"
#include "file_pager.h"
#include "opener_context.h"
#include "pager.h"
#include "paging.h"
#include "pages.h"

/* Support for providing access to files. */

class Opener
{
protected:
    Accessing *_accessing;
    Paging *_paging;
    Pages *_pages;

    /* Convenience methods. */

    Accessor *get_accessor(fileid_t fileid);

    PageMapper *get_mapper(Accessor *accessor);

    /* Configurable methods. */

    virtual fileid_t get_fileid(const char *path) = 0;

    virtual Accessor *make_accessor(fileid_t fileid) = 0;

public:
    explicit Opener(Accessing *accessing, Paging *paging, Pages *pages);

    OpenerContext *context();

    FilePager *open(const char *path);
};

// vim: tabstop=4 expandtab shiftwidth=4
